unit umainwnd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mmsystem, ExtCtrls, StdCtrls, uGamePad, Grids, StrUtils,
  ComCtrls,directinput;

{$DEFINE USETIMER}

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GBCaps: TGroupBox;
    lblCaps: TLabel;
    gbstchg: TGroupBox;
    ListBox1: TListBox;
    gbstates: TGroupBox;
    lblaxes: TLabel;
    lblbtnstitle: TLabel;
    lblbtns: TLabel;
    lblhatstitle: TLabel;
    lblhats: TLabel;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    cbgamepads: TComboBox;
    lblgpdisabled: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbgamepadsClick(Sender: TObject);
    procedure cbgamepadsChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    gcp: TGamePad;
    {$IFNDEF USETIMER}
    t3,xy,ticks: Cardinal;
    {$ENDIF}
    procedure doidle(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    {$IFNDEF USETIMER}
    Application.OnIdle:=doidle;
    ticks:=GetTickCount;
    t3:=ticks;
    xy:=0;
    {$ELSE}
    Timer1.Enabled:=True;
    {$ENDIF}
    with StringGrid1 do
    begin
        DefaultRowHeight:=16;
        Cells[0,0]:='Axis';
        Cells[1,0]:='Position in u';
        Cells[2,0]:='Velo. in u/s';
        Cells[3,0]:='Acc. in u/s^2';
        Cells[4,0]:='Range';
        RowCount:=9;
        ColWidths[0]:=50;
        ColWidths[1]:=65;
        ColWidths[2]:=65;
        ColWidths[3]:=75;
        ColWidths[4]:=50;
    end;

    gcp:=nil;
    cbgamepadsClick(nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    gcp.Free;
end;

procedure TForm1.doidle(Sender: TObject; var Done: Boolean);
    function DataToStr(p: PByte; Size: Cardinal): String;
        var i: Integer;
    begin
        Result:='';
        repeat
            for i := 7 downto 0 do
                Result:=Result+IntToStr(p^shr i and 1);
            Result:= Result+' ';
            Inc(p);
            Dec(Size);
        until Size=0;
    end;
    function HatToStr(hat: THatState): String;
    begin
        case hat of
            hsUp: Result:='up';
            hsLeft: Result:='left';
            hsRight: Result:='right';
            hsDown: Result:='down';
            hsRightUp: Result:='right up';
            hsRightDown: Result:='right down';
            hsLeftUp: Result:='left up';
            hsLeftDown: Result:='left down';
            else Result:='centered';
        end;
    end;
    var s: String; i, j: Integer;
        {$IFNDEF USETIMER}
        t2: Cardinal;
        {$ENDIF}
begin
    if(PageControl1.ActivePageIndex=0)then          //GAMEPAD
    begin
        if(gcp=nil)then
            Exit;

        if not(gcp.Enabled)then
        begin
            lblgpdisabled.Visible:=True;
            gcp.Enabled:=True;
        end else lblgpdisabled.Visible:=False;

        if(gcp.Update)then
        with gcp do
        begin
            j:=1;
            for i := 0 to 7 do
            with Axes[TAxisType(i)] do
            if(Enabled)then
            begin
                case i of
                    0: s:='X-Axis';
                    1: s:='Y-Axis';
                    2: s:='Z-Axis';
                    3: s:='Rx-Axis';
                    4: s:='Ry-Axis';
                    5: s:='Rz-Axis';
                    6: s:='Slider A';
                    7: s:='Slider B';
                end;
                with StringGrid1 do
                begin
                    Cells[0, j]:=s;
                    Cells[1, j]:=IntToStr(Pos);
                    Cells[2, j]:=IntToStr(Velo);
                    Cells[3, j]:=IntToStr(Accel);
                    Cells[4, j]:=IntToStr(Range);
                end;
                inc(j);
            end;

            //buttons
            s:='';
            for i := 0 to NumButtons-1 do
            begin
                s:=s+'btn'+IntToStr(i)+': '+IfThen(Button[i].Down, 'down', 'up')+#13;
                if(Button[i].ChangeState=bcPressed)
                then ListBox1.Items.Add(Format('btn%d pressed', [i+1]))else
                if(Button[i].ChangeState=bcReleased)
                then ListBox1.Items.Add(Format('btn%d released', [i+1]))else
                if(Button[i].ChangeState=bcRepeated)
                then ListBox1.Items.Add(Format('btn%d repeated', [i+1]));
                if(ListBox1.Items.Count>20)then
                    ListBox1.Items.Delete(0);
            end;
            lblbtns.Caption:=s;

            //hats
            s:='';
            for i := 0 to NumHats-1 do
                s:=s+'Hat_'+Inttostr(i)+': '+HatToStr(Hat[i]);
            lblhats.Caption:=s;
        end;
    end else
    if(PageControl1.ActivePageIndex=1)then                      //DIGITALIZER
    begin

    end;

    {$IFNDEF USETIMER}
    t2:=GetTickCount;
    inc(xy);
    if((t2-t3)>500)then
    begin
        try
        Caption:='Demo - '+FloatToStrF(1000*xy/(t2-t3),ffFixed,7,2)+' updates/s';
        except
            Caption:='Demo';
        end;
        t3:=t2;
        xy:=0;
    end;
    ticks:=t2;
    {$ENDIF}
end;

procedure TForm1.cbgamepadsClick(Sender: TObject);
    var i: Integer;
begin
    UpdateDevices;

    if(GamePadCount>0)then
    begin
        gcp.Free;
        gcp:=TGamePad.Create(0);
        cbgamepads.Items.Clear;
        i:=0;
        repeat
            if(i>0)then
                gcp.ID:=i;

            cbgamepads.Items.Add(gcp.InstanceName);

            Inc(i);
        until i=GamePadCount;
        cbgamepads.ItemIndex:=0;
        cbgamepadsChange(nil);
    end;
end;

procedure TForm1.cbgamepadsChange(Sender: TObject);
begin
    gcp.ID:=cbgamepads.ItemIndex;
    with gcp do
    begin
        lblCaps.Caption:=Format(
            'Instance: %s'#13'Axes: %d'#13'Buttons: %d'#13+
            'Hats: %d'#13'Sliders: %d',
            [InstanceName,NumAxes,NumButtons,NumHats,NumSliders]
        );
        StringGrid1.RowCount:=1+NumAxes+NumSliders;
    end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
    var dummy: boolean;
begin
    doidle(nil, dummy);
end;

end.
